BEGIN TRANSACTION            
			  DECLARE @JobID BINARY(16)  
			  DECLARE @ReturnCode INT    
			  SELECT @ReturnCode = 0     
			IF (SELECT COUNT(*) FROM msdb.dbo.syscategories WHERE name = N'[Uncategorized (Local)]') < 1 
			  EXECUTE msdb.dbo.sp_add_category @name = N'[Uncategorized (Local)]'
			
			  -- Delete the job with the same name (if it exists)
			  SELECT @JobID = job_id     
			  FROM   msdb.dbo.sysjobs    
			  WHERE (name = N'Site_ContasBloc')       
			  IF (@JobID IS NOT NULL)    
			  BEGIN  
			  -- Check if the job is a multi-server job  
			  IF (EXISTS (SELECT  * 
						  FROM    msdb.dbo.sysjobservers 
						  WHERE   (job_id = @JobID) AND (server_id <> 0))) 
			  BEGIN 
				-- There is, so abort the script 
				RAISERROR (N'Impossvel Importar a JOB ''Site_ContasBloc'' uma vez que j existe uma JOB com esse nome no servidor multi-tarefa.', 16, 1) 
				GOTO QuitWithRollback  
			  END 
			  ELSE 
				-- Delete the [local] job 
				EXECUTE msdb.dbo.sp_delete_job @job_name = N'Site_ContasBloc' 
				SELECT @JobID = NULL
			  END 
			
			BEGIN 
			
			  -- Add the job
			  EXECUTE @ReturnCode = msdb.dbo.sp_add_job @job_id = @JobID OUTPUT , @job_name = N'Site_ContasBloc', @owner_login_name = N'sa', @description = N'No description available.', @category_name = N'[Uncategorized (Local)]', @enabled = 1, @notify_level_email = 0, @notify_level_page = 0, @notify_level_netsend = 0, @notify_level_eventlog = 2, @delete_level= 0
			  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 
			
			  -- Add the job steps
			  EXECUTE @ReturnCode = msdb.dbo.sp_add_jobstep @job_id = @JobID, @step_id = 1, @step_name = N'Site_ContasBloc', @command = N'Update MEMB_INFO set bloc_code=0, diasdesbloc=0, databloc=NULL, motivobloc=NULL, blocpor=NULL WHERE bloc_code=1 AND databloc<=getdate()-diasdesbloc', @database_name = N'MuOnline', @server = N'', @database_user_name = N'', @subsystem = N'TSQL', @cmdexec_success_code = 0, @flags = 0, @retry_attempts = 0, @retry_interval = 1, @output_file_name = N'', @on_success_step_id = 0, @on_success_action = 1, @on_fail_step_id = 0, @on_fail_action = 2
			  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 
			  EXECUTE @ReturnCode = msdb.dbo.sp_update_job @job_id = @JobID, @start_step_id = 1 
			
			  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 
			
			  -- Add the job schedules
			  EXECUTE @ReturnCode = msdb.dbo.sp_add_jobschedule @job_id = @JobID, @name = N'Site_ContasBloc', @enabled = 1, @freq_type = 4, @active_start_date = 20070719, @active_start_time = 0, @freq_interval = 1, @freq_subday_type = 4, @freq_subday_interval = 1, @freq_relative_interval = 0, @freq_recurrence_factor = 0, @active_end_date = 99991231, @active_end_time = 235959
			  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 
			
			  -- Add the Target Servers
			  EXECUTE @ReturnCode = msdb.dbo.sp_add_jobserver @job_id = @JobID, @server_name = N'(local)' 
			  IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback 
			
			END
			COMMIT TRANSACTION          
			GOTO   EndSave              
			QuitWithRollback:
			  IF (@@TRANCOUNT > 0) ROLLBACK TRANSACTION 
			EndSave: 